kind: ConfigMap
apiVersion: v1
metadata:
  creationTimestamp: 2016-02-18T19:14:38Z
  name: kube-gelf
  namespace: kube-system
data:
  GELF_HOST: "{{ kubespray_fluentd_gelf_host }}"
  GELF_PORT: "{{ kubespray_fluentd_gelf_port }}"
  GELF_PROTOCOL: "{{ kubespray_fluentd_gelf_protocol }}"
  fluent.conf: |-
    <match fluent.**>
      @type null
    </match>

    <source>
      @type systemd
      tag systemd
      path /var/log/journal
      <storage>
        @type local
        persistent true
        path /pos
      </storage>
      <entry>
        field_map {"MESSAGE": "log", "_PID": ["process", "pid"], "_CMDLINE": "process", "_COMM": "cmd"}
        fields_strip_underscores true
        fields_lowercase true
      </entry>
      read_from_head true
    </source>

    <source>
      @type tail
      path /var/log/containers/*.log
      pos_file /pos/containers.pos
      time_key time
      time_format %Y-%m-%dT%H:%M:%S.%NZ
      tag kubernetes.*
      format json
      read_from_head true
    </source>

    <filter kubernetes.**>
      @type kubernetes_metadata
      ca_file /var/run/secrets/kubernetes.io/serviceaccount/ca.crt
      bearer_token_file /var/run/secrets/kubernetes.io/serviceaccount/token
    </filter>

    <filter access>
      @type record_transformer
      <record>
        hostname "#{ENV['NODENAME']}"
      </record>
    </filter>

    <match **>
       @type copy
       <store>
         @type gelf
         include_tag_key true
         host "#{ENV['GELF_HOST']}"
         port "#{ENV['GELF_PORT']}"
         # protocol <tcp or udp>
         protocol "#{ENV['GELF_PROTOCOL']}"
         # tls <true or false>
         # tls_options {}
         # Supported tls_options:
         # 'no_default_ca' [Boolean] prevents OpenSSL from using the systems CA store.
         # 'tls_version' [Symbol] any of :TLSv1, :TLSv1_1, :TLSv1_2 (default)
         # 'cert' [String, IO] the client certificate file
         # 'key' [String, IO] the key for the client certificate
         # 'all_ciphers' [Boolean] allows any ciphers to be used, may be insecure
         flush_interval 10s
         num_threads 2
         use_record_host true
         buffer_chunk_limit 4096K
         buffer_queue_limit 512
         max_retry_wait 300
       </store>
    </match>

    # Valid log_level's are: fatal, error, warn, info, debug, trace
    <system>
      log_level warn
    </system>
